using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using System.Data.OleDb;

public partial class _Default : System.Web.UI.Page
{
    private static DataTable GetDataTable(string query)
        {
            OleDbConnection connection1 = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" + System.Web.HttpContext.Current.Server.MapPath("~/App_Data/db1.mdb"));
            OleDbDataAdapter adapter1 = new OleDbDataAdapter();
            adapter1.SelectCommand = new OleDbCommand(query, connection1);
            DataTable table1 = new DataTable();
            connection1.Open();
            try
            {
                adapter1.Fill(table1);
            }
            finally
            {
                connection1.Close();
            }
            return table1;
        }

        protected void RadGrid1_NeedDataSource(object source, Telerik.Web.UI.GridNeedDataSourceEventArgs e)
        {
            RadGrid1.DataSource = GetDataTable("SELECT * FROM SelfReferencing");
        }

        protected void RadGrid1_ColumnCreated(object sender, GridColumnCreatedEventArgs e)
        {
            if (e.Column.IsBoundToFieldName("ID") || e.Column.IsBoundToFieldName("ParentID"))
            {
                e.Column.Visible = false;
            }
        }

        public void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                RadGrid1.MasterTableView.FilterExpression = "ParentID = 0";
            }
        }

        protected void RadGrid1_ItemCreated(object sender, GridItemEventArgs e)
        {
            if (e.Item is GridHeaderItem)
            {
                e.Item.Style["display"] = "none";
            }
        }


        public void Page_PreRenderComplete(object sender, EventArgs e)
        {
            HideExpandColumnRecursive(RadGrid1.MasterTableView);
        }

    public void HideExpandColumnRecursive(GridTableView tableView)
    {
        GridItem[] nestedViewItems = tableView.GetItems(GridItemType.NestedView);
        foreach (GridNestedViewItem nestedViewItem in nestedViewItems)
        {
            foreach (GridTableView nestedView in nestedViewItem.NestedTableViews)
            {
                foreach (GridDataItem dataitem in nestedView.Items)
                {
                    if (dataitem["Name"].Text == "Tester 2")
                    {
                        dataitem.BackColor = System.Drawing.Color.Red;
                        nestedView.ParentItem.BackColor = System.Drawing.Color.Red;
                        nestedView.ParentItem.OwnerTableView.ParentItem.BackColor = System.Drawing.Color.Red;
                    }
                }
                if (nestedView.Items.Count == 0)
                {
                    TableCell cell = nestedView.ParentItem["ExpandColumn"];
                    cell.Controls[0].Visible = false;
                    nestedViewItem.Visible = false;
                }

                if (nestedView.HasDetailTables)
                {
                    HideExpandColumnRecursive(nestedView);
                }
            }
        }
    }

}
